/*
   event horizon - lua/c++ event system demonstration
   Copyright (c) 2006 kevin meinert all rights reserved

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301  USA
   */

#include "packet.h"

/// a custom data packet for testing...
/// the "packet_" description generator...
struct MyPacket
{
   int int1, int2;
   char str1[16], str2[64];
   float fl1, fl2;
   int int3[5], int4[4];
   float fl3[3], fl4[14];
   bool b1[3], b2[14];

   static packet& getdef()
   {
      static packet o = 
         packet_<MyPacket>( "MyPacket" )
            .add( "int1", &MyPacket::int1 )
            .add( "int2", &MyPacket::int2 )
            .add( "str1", &MyPacket::str1 )
            .add( "str2", &MyPacket::str2 )
            .add( "fl1", &MyPacket::fl1 )
            .add( "fl2", &MyPacket::fl2 )
            .add( "int3", &MyPacket::int3 )
            .add( "int4", &MyPacket::int4 )
            .add( "fl3", &MyPacket::fl3 )
            .add( "fl4", &MyPacket::fl4 )
            .add( "b1", &MyPacket::b1 )
            .add( "b2", &MyPacket::b2 );
      return o;
   }
};

// application entry point.
int main( int argc, char* argv[] )
{
   packet o = MyPacket::getdef();
   for (unsigned int x = 0; x < o.attribs.size(); ++x)
   {
      printf( "%s::%s[%d] [ objsize:%d ][ type:%d varsize:%d offset:%d\n", o.name, o.attribs[x].name, o.attribs[x].length, o.size, o.attribs[x].type, o.attribs[x].size, o.attribs[x].location );
   }
}
